<?php

/*

    recfriioの操作関数

*/


// 起動
function exec_recfriio( $operate, &$setting, &$errmsg )
{
    if( $operate != OP_PLAY && $operate != OP_REC ) return FALSE;

    show_debug( 'exec_recfriio : operate = '.$operate );

    $status = get_default_status();

    // チャンネル
    $status[ CHANNEL ] = $setting[ SET_CHANNEL ];

    // 時間
    $status[ DURATION ] = $setting[ SET_DURATION ] * 60;
    if( $status[ DURATION ] <= 0 ){
        $errmsg = 'エラー(exec_recfriio) : 録画時間が正しくありません。';
        return FALSE;
    }

    // ファイル名
    if( $operate == OP_PLAY ){  // 再生のみの場合
        $status[ OUTDIR ] = '';
        $status[ OUTNAME ] = '/dev/null';
    }
    else{

        if( ! $setting[ SET_OUTDIR ] ){
            $errmsg = 'エラー(exec_recfriio) : ディレクトリが指定されていません。';
            return FALSE;
        }

        if( ! $setting[ SET_NAMEBASE ] ){
            $errmsg = 'エラー(exec_recfriio) : ファイル名が指定されていません。';
            return FALSE;
        }

        // ディレクトリの最後が'/'の時は削除
        $dir = $setting[ SET_OUTDIR ];
        if( $dir && $dir[ strlen( $dir ) -1 ] == '/' ) $dir = substr( $dir, 0, strlen( $dir )-1 );

        $status[ OUTDIR ] = $dir;
        $status[ OUTNAME ] = get_filename( $setting, time() );
    }

    // UDP送信
    $status[ UDP ] = $setting[ SET_UDP ];
    $status[ IP ] = $setting[ SET_IP ];
    $status[ PORT ] = $setting[ SET_PORT ];

    if( $status[ UDP ] ){

        if( ! $status[ IP ] ){
            $errmsg = 'エラー(exec_recfriio) : IPが指定されていません。';
            return FALSE;
        }
        if( ! $status[ PORT ] ){
            $errmsg = 'エラー(exec_recfriio) : ポートが指定されていません。';
            return FALSE;
        }
    }

    $command = 
        'HOMEDIR="'.HOME.'" '.
        'STATDIR="'.STATDIR.'" '.
        'STATBASE="'.STATBASE.'" '.

        'CHANNEL="'.$status[ CHANNEL ].'" '.
        'DURATION="'.$status[ DURATION ].'" '.
        'OUTDIR="'.$status[ OUTDIR ].'" '.
        'OUTNAME="'.$status[ OUTNAME ].'" '.

        'UDP="'.$status[ UDP ].'" '.
        'IP="'.$status[ IP ].'" '.
        'PORT="'.$status[ PORT ].'" '.

        RECORD_SCRIPT
        ;

    show_debug( $command );

    exec( $command.' > /dev/null &' );
    sleep( WAITTIME );

    return TRUE;
}


// 停止
function stop_recfriio( $pid )
{
    show_debug( 'stop_recfriio pid = '.$pid );

    $command = KILLCMD.' '.$pid;
    show_debug( $command );

    exec( $command );
    sleep( WAITTIME );
}

?>