<?php

/*

    ユーティリティ関数

*/


// デフォルトステータス値
function get_default_status()
{
    return array( 0, // PID
                  0, // CHANNEL
                  0, // STARTTIME
                  0, // DURATION
                  '', // OUTNAME
                  0, // UDP
                  '', // IP
                  0 // PORT
        );
}


// デフォルト設定値
function get_default_setting()
{
    return array(
                  '', // SET_COMMENT
                  0, // SET_CHANNEL
                  60, // SET_DURATION
                  SPOOL_DIRECTORY, // SET_OUTDIR
                  '', // SET_NAMEBASE
                  0, // SET_OVERWRITE
                  0, // SET_UDP
                  'localhost', // SET_IP
                  1234 // SET_PORT
        );
}


// 保存ファイル名取得
// 上書きしない場合は日付を追加
function get_filename( &$setting, $starttime  )
{
    $file = $setting[ SET_NAMEBASE ];
    if( ! $setting[ SET_OVERWRITE ] ) $file = $file.'-'.date( 'ymdHis', $starttime );

    return $file;
}


// csvファイル読み込み
function read_csv( $file, &$data, &$errmsg )
{
    show_debug( 'read_csv : '.$file );

    $data = array();

    if( ! file_exists( $file ) ){
        $errmsg = 'エラー(read_csv) :ファイル('.$file.')が存在しません。';
        return FALSE;
    }

    if( ! ( $fp = fopen( $file, 'r') ) ){
        $errmsg = 'エラー(read_csv) :ファイル('.$file.')のオープンに失敗しました。';
        return FALSE;
    }
    while( $tmp = fgetcsv( $fp ) ) $data[] = $tmp;
    fclose( $fp );

    return TRUE;
}


// csvファイル書き込み
function save_csv( $file, &$data, &$errmsg )
{
    show_debug( 'save_csv : '.$file );

    if( ! is_array( $data ) ) return FALSE;

    if( ! ( $fp = fopen( $file, 'w+') ) ){
        $errmsg = 'エラー(save_csv) :ファイル('.$file.')のオープンに失敗しました。';
        return FALSE;
    }

    foreach( $data as $line ) fputcsv( $fp, $line );
    fclose( $fp );

    return TRUE;
}


// ステータスファイルの読み込み
function read_statusfile( $file, &$status, &$errmsg )
{
    $data = array();
    if( ! read_csv( $file, $data, $errmsg ) ) return FALSE;
    $status = $data[ 0 ];
    if( ! is_array( $status ) || count( $status ) != STATUSSIZE ) return FALSE;

    return TRUE;
}


// プロセスが動いているか
function is_running( $pid )
{
    if( $pid ){

        show_debug( 'is_running : pid = '.$pid );

        $ret = exec( 'ps --no-headers -p '.$pid );
        show_debug( $ret );

        if( $ret ) return TRUE;
    }

    return FALSE;
}


?>
