<?php

/*

   表示関係関数

*/


// ステータス行表示
function show_status( &$status )
{
    if( ! is_array( $status ) ) return FALSE;
    if( count( $status ) != STATUSSIZE ) return FALSE;

    $pid = $status[ PID ];

    global $CHANNEL_TABLE;
    $channel = $CHANNEL_TABLE[ $status[ CHANNEL ] ].'('.$status[ CHANNEL ].')';

    $starttime = date( 'm/d H:i:s', $status[ STARTTIME ] );
    $duration = $status[ DURATION ];
    $sec = time() - $status[ STARTTIME ];

    $outname = $status[ OUTNAME ];
    if( $outname == '/dev/null' ) $outname = '-';

    $udp = '-';
    $ip = '-';
    $port = '-';
    if( $status[ UDP ] ){
         $udp = '送信中';
         $ip = $status[ IP ];
         $port = $status[ PORT ];
    }

    print(
        '<tr align=center>'.
        '<td>'.$pid.'</td>'.
        '<td>'.$channel.'</td>'.
        '<td>'.$starttime.'</td>'.
        '<td>'.$sec.'/'.$duration.'</td>'.
        '<td>'.$outname.'</td>'.
        '<td>'.$udp.'</td>'.
        '<td>'.$ip.'</td>'.
        '<td>'.$port.'</td>'.

        '<td>'.
        '<form action="status.php" method="post">'.
        '<input type="hidden" name="pid" value="'.$pid.'">'.
        '<input type="submit" value="■">'.
        '</form>'.
        '</td>'.

        '</tr>'
        );

    return TRUE;
}



// 設定表示
function show_setting( $settingno, &$setting )
{
    if( ! is_array( $setting ) | count( $setting ) != SET_SIZE ) return FALSE;

    global $CHANNEL_TABLE;

    print(

        '<tr align=center>'.

        '<form action="recfriio.php" method="post">'.
        '<input type="hidden" name="number" value="'.$settingno.'">'.

        '<td>'.
        '<input type="text" size=12 name="comment" value="'.$setting[ SET_COMMENT ].'">'.
        '</td>'.

        '<td>'.
        '<select name="channel">'
        );

    foreach( $CHANNEL_TABLE as $ch => $chname ){

        print(
            '<option'
            );
        if( $ch == $setting[ SET_CHANNEL ] ) print( ' selected' );
        print(
            '>'.$chname.'('.$ch.')'.
            '</option>'
            );
    }

    print(
        '</select>'.
        '</td>'.

        '<td>'.
        '<input type="text" size=5 maxlength=5 name="duration" value="'.$setting[ SET_DURATION ].'">'.
        '</td>'.

        '<td>'.
        '<input type="text" size=10 name="namebase" value="'.$setting[ SET_NAMEBASE ].'">'.
        '</td>'.

        '<td>'.
        '<input type="checkbox" name="overwrite" value="1"'.( $setting[ SET_OVERWRITE ] ? '' : 'checked' ).'>しない'.
        '</td>'.

        '<td>'.
        '<input type="checkbox" name="udp" value="1"'.($setting[ SET_UDP ] ? 'checked' : '' ).'>送信'.
        '</td>'.

        '<td>'.
        '<input type="text" size=10 name="ip" value="'.$setting[ SET_IP ].'">'.
        '</td>'.

        '<td>'.
        '<input type="text" size=5 maxlength=5 name="port" value="'.$setting[ SET_PORT ].'">'.
        '</td>'.

        '<td>'.
        '<input type="submit" name="play" value="＞">'.
        '</td>'.

        '<td>'.
        '<input type="submit" name="rec" value="●">'.
        '</td>'.

        '</form>'.
        '</tr>'.
        "\n"
        );

    return TRUE;
}


// エラー表示
function show_err( &$errmsg )
{
    if( $errmsg ) print( '<br /><table border=2 class="err" ><tr><th>'.$errmsg.'</th></tr></table>' );
}


?>
