<?php

/*

    本体

*/

require_once( "config.php" );
require_once( "config-recfriio.php" );

require_once( "librecfriio/const.php" );
require_once( "librecfriio/debug.php" );
require_once( "librecfriio/view.php" );
require_once( "librecfriio/utility.php" );
require_once( "librecfriio/operate.php" );

setlocale( LC_ALL, 'ja_JP.UTF-8' ); // 入れておかないと日本語が含まれる時に fgetcsv() が失敗する
$errmsg = '';

$setting_array = array();
if( file_exists( SETTINGFILE ) ) read_csv( SETTINGFILE, $setting_array, $errmsg );

// 視聴/録画ボタンを押した場合
$number = -1;
if( isset( $_POST[ 'number' ] ) ){
    $number = $_POST[ 'number' ];
    show_debug( 'number = '.$number );
}

// 設定更新
$save_setting = FALSE;
for( $settingno = 1; $settingno <= MAXSETTING; ++$settingno ){

    if( count( $setting_array ) < $settingno ){
        $setting_array[ $settingno -1 ] = get_default_setting();
        $save_setting = TRUE;
    }

    $setting = &$setting_array[ $settingno -1 ];

    if( ! is_array( $setting ) || count( $setting ) != SET_SIZE ){
        $setting = get_default_setting();
        $save_setting = TRUE;
    }

    if( $settingno == $number ){

        // 操作
        $operate = OP_NONE;
        if( isset( $_POST[ 'play' ] ) ) $operate = OP_PLAY;
        if( isset( $_POST[ 'rec' ] ) ) $operate = OP_REC;

        // コメント
        if( isset( $_POST[ 'comment' ] ) ) $setting[ SET_COMMENT ] = $_POST[ 'comment' ];

        // チャンネル
        if( isset( $_POST[ 'channel' ] ) ){

            $channel = -1;
            foreach( $CHANNEL_TABLE as $ch => $chname ){

                if( $_POST[ 'channel' ] == $chname.'('.$ch.')' ){
                    $channel = $ch;
                    break;
                }
            }

            $setting[ SET_CHANNEL ] = $channel;
        }

        // 秒
        if( isset( $_POST[ 'duration' ] ) ) $setting[ SET_DURATION ] = $_POST[ 'duration' ];

        // ディレクトリ
        $setting[ SET_OUTDIR ] = SPOOL_DIRECTORY;

        // ファイル名
        if( isset( $_POST[ 'namebase' ] ) ) $setting[ SET_NAMEBASE ] = $_POST[ 'namebase' ];
        if( isset( $_POST[ 'overwrite' ] ) ) $setting[ SET_OVERWRITE ] = 0;
        else $setting[ SET_OVERWRITE ] = 1;

        // UDP送信
        if( isset( $_POST[ 'udp' ] ) ) $setting[ SET_UDP ] = 1;
        else $setting[ SET_UDP ] = 0;
        if( isset( $_POST[ 'ip' ] ) ) $setting[ SET_IP ] = $_POST[ 'ip' ];
        if( isset( $_POST[ 'port' ] ) ) $setting[ SET_PORT ] = $_POST[ 'port' ];

        exec_recfriio( $operate, $setting, $errmsg );

        $save_setting = TRUE;
    }
}

if( $save_setting ) save_csv( SETTINGFILE, $setting_array, $errmsg );

$freesize = disk_free_space( SPOOL_DIRECTORY );

print(
    '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">'.
    '<html lang="ja">'.
    '<head>'.
    '<meta http-equiv="content-type" content="text/html; charset=utf-8">'.
    '<title>recfriio server</title>'.
    '<link rel="stylesheet" href="recfriio.css" type="text/css">'.
    '</head>'.
    '<body>'.
    'ディスク空き容量 '.(int)($freesize/1024/1024/1024).' G<br><br>'.
    '<div class="title">設定</div>'.

    '<table border=2>'.
    '<tr>'.
    '<th>設定名</th>'.
    '<th>チャンネル</th>'.
    '<th>分</th>'.
    '<th>ファイル名</th>'.
    '<th>上書き</th>'.
    '<th>UDP</th>'.
    '<th>IP</th>'.
    '<th>ポート</th>'.
    '<th>視聴</th>'.   
    '<th>録画</th>'.
    '</tr>'
    );

for( $settingno = 1; $settingno <= MAXSETTING; ++$settingno ){
    show_setting( $settingno, $setting_array[ $settingno -1 ] );
}

print( '</table>' );

// エラー表示
show_err( $errmsg );

?>

<br />
<br />
<div class="title">動作状況</div>
<a href="./recfriio.php">表示更新</a>
<br />
<iframe src="status.php" width="100%" height="200px" frameborder="0">
お使いのブラウザでは動作状況を表示出来ません。
</iframe>

</body>
</html>
