<?php

/*

    ステータス表示

*/

require_once( "config.php" );
require_once( "config-recfriio.php" );

require_once( "librecfriio/const.php" );
require_once( "librecfriio/debug.php" );
require_once( "librecfriio/view.php" );
require_once( "librecfriio/utility.php" );
require_once( "librecfriio/operate.php" );

setlocale( LC_ALL, 'ja_JP.UTF-8' );  // 入れておかないと日本語が含まれる時に fgetcsv() が失敗する
$errmsg = '';

if( $_SERVER[ "REQUEST_METHOD" ] == "POST" ){

    //リロード時の POST 再送信対策
    header( 'Location: '.$_SERVER[ 'PHP_SELF' ] );

    // 停止ボタンを押したら recfriio を停止する
    if( isset( $_POST[ 'pid' ] ) ) stop_recfriio( $_POST[ 'pid' ] );

    exit;
}

print(
    '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">'.
    '<html lang="ja">'.
    '<head>'.
    '<meta http-equiv="content-type" content="text/html; charset=utf-8">'.
    '<link rel="stylesheet" href="recfriio.css" type="text/css">'.
    '</head>'.
    '<body>'
);


// 更新間隔をセット
print(
    '<script language="JavaScript">'.
    "<!--\n".
    'setTimeout( "location.reload()", 1000 * '.REFRESH.' ); '.
    '//-->'.
    '</script>'
);


// ステータス表示
print(
    '<table border=2>'.
    '<tr>'.
    '<th>PID</th>'.
    '<th>チャンネル</th>'.
    '<th>開始時刻</th>'.
    '<th>経過</th>'.
    '<th>出力先</th>'.
    '<th>UDP</th>'.
    '<th>IP</th>'.
    '<th>ポート</th>'.
    '<th>停止</th>'.
    '</tr>'
    );

// ステータスディレクトリ(STATDIR)内のファイルをスキャンしてステータス表示
$files = scandir( './'.STATDIR );
if( ! $files ){
    $errmsg = 'エラー(status) : ステータスディレクトリ('.STATDIR.')を開けません。パーミッション等を確認してください。';
}
else foreach( $files as $file ){

    if( strncmp( $file, STATBASE, strlen( STATBASE ) ) == 0 ){

        $file = './'.STATDIR.'/'.$file;
        show_debug( $file );

        if( read_statusfile( $file, $status, $errmsg ) ){

            // プロセスは停止しているのにステータスファイルが残っている場合はファイルを消す
            if( ! is_running( $status[ PID ] ) ){
                unlink( $file );
                show_debug( 'unlink '.$file );
            }

            // ステータス表示
            else show_status( $status );
        }
        if( $errmsg ) break;
    }
}

print( '</table>' );

// エラー表示
show_err( $errmsg );

?>

</body>
</html>
